//: C05:TemplateFunctionAddress.cpp {-mwcc}
// Z knihy "Myslíme v jazyce C++, část 2" od Bruce Eckela a Chucka Allisona.
// (c) 1995-2004 MindView, Inc. Všechna práva vyhrazena.
// Přečtěte si podmínky používání zdrojových kódů umístěné v souboru 
// 'Licence.txt' dodávaném spolu s balíčkem kódu dostupným na www.MindView.net.
// Zjištění adresy funkce vygenerované ze šablony.

template<typename T> void f(T*) {}

void h(void (*pf)(int*)) {}

template<typename T> void g(void (*pf)(T*)) {}

int main() {
  h(&f<int>); // Plná specifikace typu
  h(&f); // Odvození typu
  g<int>(&f<int>); // Plná specifikace typu
  g(&f<int>); // Odvození typu
  g<int>(&f); // Částečná (ale dostatečná) specifikace
} ///:~
